diff --git a/freebsd/sys/kern/vfs_bio.c b/freebsd/sys/kern/vfs_bio.c
index 2277bf67..50e87ff8 100644
--- a/freebsd/sys/kern/vfs_bio.c
+++ b/freebsd/sys/kern/vfs_bio.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-2-Clause-FreeBSD
  *
@@ -54,7 +56,9 @@ __FBSDID("$FreeBSD$");
 #include <sys/conf.h>
 #include <sys/counter.h>
 #include <sys/buf.h>
+#ifndef __rtems__
 #include <sys/devicestat.h>
+#endif /* __rtems__ */
 #include <sys/eventhandler.h>
 #include <sys/fail.h>
 #include <sys/limits.h>
@@ -85,8 +89,10 @@ __FBSDID("$FreeBSD$");
 #include <vm/vm_pager.h>
 #include <vm/vm_extern.h>
 #include <vm/vm_map.h>
+#ifndef __rtems__
 #include <vm/swap_pager.h>
-#include "opt_swap.h"
+#endif /* __rtems__ */
+#include <rtems/bsd/local/opt_swap.h>
 
 static MALLOC_DEFINE(M_BIOBUF, "biobuf", "BIO buffer");
 
@@ -147,7 +153,15 @@ struct bufdomain {
 #define	BD_DOMAIN(bd)		(bd - bdomain)
 
 static struct buf *buf;		/* buffer header pool */
+#ifndef __rtems__
 extern struct buf *swbuf;	/* Swap buffer header pool. */
+#else /* __rtems__ */
+#define VPR_NOREUSE 0
+#define VPR_TRYFREE 0
+#define bogus_page (NULL + 1)
+#define num_pages(x) \
+        ((vm_offset_t)((((vm_offset_t)(x)) + PAGE_MASK) >> PAGE_SHIFT))
+#endif /* __rtems__ */
 caddr_t __read_mostly unmapped_buf;
 
 /* Used below and for softdep flushing threads in ufs/ffs/ffs_softdep.c */
@@ -791,12 +805,16 @@ bufspace_daemon(void *arg)
 {
 	struct bufdomain *bd;
 
+#ifndef __rtems__
 	EVENTHANDLER_REGISTER(shutdown_pre_sync, kthread_shutdown, curthread,
 	    SHUTDOWN_PRI_LAST + 100);
+#endif /* __rtems__ */
 
 	bd = arg;
 	for (;;) {
+#ifndef __rtems__
 		kthread_suspend_check();
+#endif /* __rtems__ */
 
 		/*
 		 * Free buffers from the clean queue until we meet our
@@ -844,7 +862,9 @@ bufspace_daemon(void *arg)
 				} else
 					BD_UNLOCK(bd);
 			}
+#ifndef __rtems__
 			maybe_yield();
+#endif /* __rtems__ */
 		}
 		bufspace_daemon_wait(bd);
 	}
@@ -953,6 +973,7 @@ static __inline void
 vfs_buf_test_cache(struct buf *bp, vm_ooffset_t foff, vm_offset_t off,
     vm_offset_t size, vm_page_t m)
 {
+#ifndef __rtems__
 
 	VM_OBJECT_ASSERT_LOCKED(m->object);
 	if (bp->b_flags & B_CACHE) {
@@ -960,6 +981,7 @@ vfs_buf_test_cache(struct buf *bp, vm_ooffset_t foff, vm_offset_t off,
 		if (vm_page_is_valid(m, base, size) == 0)
 			bp->b_flags &= ~B_CACHE;
 	}
+#endif /* __rtems__ */
 }
 
 /* Wake up the buffer daemon if necessary */
@@ -1017,9 +1039,11 @@ bd_speedup(void)
 	mtx_unlock(&bdlock);
 }
 
+#ifndef __rtems__
 #ifndef NSWBUF_MIN
 #define	NSWBUF_MIN	16
 #endif
+#endif /* __rtems__ */
 
 #ifdef __i386__
 #define	TRANSIENT_DENOM	5
@@ -1129,6 +1153,7 @@ kern_vfs_bio_buffer_alloc(caddr_t v, long physmem_est)
 			nbuf = buf_sz / BKVASIZE;
 	}
 
+#ifndef __rtems__
 	/*
 	 * swbufs are used as temporary holders for I/O, such as paging I/O.
 	 * We have no less then 16 and no more then 256.
@@ -1137,12 +1162,15 @@ kern_vfs_bio_buffer_alloc(caddr_t v, long physmem_est)
 	TUNABLE_INT_FETCH("kern.nswbuf", &nswbuf);
 	if (nswbuf < NSWBUF_MIN)
 		nswbuf = NSWBUF_MIN;
+#endif /* __rtems__ */
 
 	/*
 	 * Reserve space for the buffer cache buffers
 	 */
+#ifndef __rtems__
 	swbuf = (void *)v;
 	v = (caddr_t)(swbuf + nswbuf);
+#endif /* __rtems__ */
 	buf = (void *)v;
 	v = (caddr_t)(buf + nbuf);
 
@@ -1164,7 +1192,12 @@ bufinit(void)
 	mtx_init(&bdlock, "buffer daemon lock", NULL, MTX_DEF);
 	mtx_init(&bdirtylock, "dirty buf lock", NULL, MTX_DEF);
 
+#ifndef __rtems__
 	unmapped_buf = (caddr_t)kva_alloc(MAXPHYS);
+#else /* __rtems__ */
+	extern caddr_t unmapped_base;
+	unmapped_buf = (caddr_t)unmapped_base;
+#endif /* __rtems__ */
 
 	/* finally, initialize each buffer header and stick on empty q */
 	for (i = 0; i < nbuf; i++) {
@@ -1252,7 +1285,9 @@ bufinit(void)
 	numfreebuffers = nbuf;
 
 	/* Setup the kva and free list allocators. */
+#ifndef __rtems__
 	vmem_set_reclaim(buffer_arena, bufkva_reclaim);
+#endif /* __rtems__ */
 	buf_zone = uma_zcache_create("buf free cache", sizeof(struct buf),
 	    NULL, NULL, NULL, NULL, buf_import, buf_release, NULL, 0);
 
@@ -1335,6 +1370,7 @@ isbufbusy(struct buf *bp)
 void
 bufshutdown(int show_busybufs)
 {
+#ifndef __rtems__
 	static int first_buf_printf = 1;
 	struct buf *bp;
 	int iter, nbusy, pbusy;
@@ -1441,6 +1477,7 @@ bufshutdown(int show_busybufs)
 	}
 	swapoff_all();
 	DELAY(100000);		/* wait for console output to finish */
+#endif /* __rtems__ */
 }
 
 static void
@@ -1454,7 +1491,9 @@ bpmap_qenter(struct buf *bp)
 	 * bp->b_offset may be offset into the first page.
 	 */
 	bp->b_data = (caddr_t)trunc_page((vm_offset_t)bp->b_data);
+#ifndef __rtems__
 	pmap_qenter((vm_offset_t)bp->b_data, bp->b_pages, bp->b_npages);
+#endif /* __rtems__ */
 	bp->b_data = (caddr_t)((vm_offset_t)bp->b_data |
 	    (vm_offset_t)(bp->b_offset & PAGE_MASK));
 }
@@ -2103,7 +2142,9 @@ breada(struct vnode * vp, daddr_t * rablkno, int * rabsize, int cnt,
 			PROC_UNLOCK(curproc);
 		}
 #endif /* RACCT */
+#ifndef __rtems__
 		td->td_ru.ru_inblock++;
+#endif /* __rtems__ */
 		rabp->b_flags |= B_ASYNC;
 		rabp->b_flags &= ~B_INVAL;
 		if ((flags & GB_CKHASH) != 0) {
@@ -2166,7 +2207,9 @@ breadn_flags(struct vnode *vp, daddr_t blkno, int size, daddr_t *rablkno,
 			PROC_UNLOCK(td->td_proc);
 		}
 #endif /* RACCT */
+#ifndef __rtems__
 		td->td_ru.ru_inblock++;
+#endif /* __rtems__ */
 		bp->b_iocmd = BIO_READ;
 		bp->b_flags &= ~B_INVAL;
 		if ((flags & GB_CKHASH) != 0) {
@@ -2274,7 +2317,9 @@ bufwrite(struct buf *bp)
 		PROC_UNLOCK(curproc);
 	}
 #endif /* RACCT */
+#ifndef __rtems__
 	curthread->td_ru.ru_oublock++;
+#endif /* __rtems__ */
 	if (oldflags & B_ASYNC)
 		BUF_KERNPROC(bp);
 	bp->b_iooffset = dbtob(bp->b_blkno);
@@ -2835,6 +2880,9 @@ out:
 static void
 vfs_vmio_iodone(struct buf *bp)
 {
+#ifdef __rtems__
+  panic(__func__);
+#else /* __rtems__ */
 	vm_ooffset_t foff;
 	vm_page_t m;
 	vm_object_t obj;
@@ -2901,6 +2949,7 @@ vfs_vmio_iodone(struct buf *bp)
 		pmap_qenter(trunc_page((vm_offset_t)bp->b_data),
 		    bp->b_pages, bp->b_npages);
 	}
+#endif /* __rtems__ */
 }
 
 /*
@@ -2916,7 +2965,9 @@ vfs_vmio_invalidate(struct buf *bp)
 
 	if (buf_mapped(bp)) {
 		BUF_CHECK_MAPPED(bp);
+#ifndef __rtems__
 		pmap_qremove(trunc_page((vm_offset_t)bp->b_data), bp->b_npages);
+#endif /* _-rtems__ */
 	} else
 		BUF_CHECK_UNMAPPED(bp);
 	/*
@@ -2942,6 +2993,7 @@ vfs_vmio_invalidate(struct buf *bp)
 			panic("vfs_vmio_invalidate: Unexpected bogus page.");
 		bp->b_pages[i] = NULL;
 
+#ifndef __rtems__
 		presid = resid > (PAGE_SIZE - poffset) ?
 		    (PAGE_SIZE - poffset) : resid;
 		KASSERT(presid >= 0, ("brelse: extra page"));
@@ -2954,6 +3006,7 @@ vfs_vmio_invalidate(struct buf *bp)
 		if (pmap_page_wired_mappings(m) == 0)
 			vm_page_set_invalid(m, poffset, presid);
 		vm_page_release_locked(m, flags);
+#endif /* __rtems__ */
 		resid -= presid;
 		poffset = 0;
 	}
@@ -2976,8 +3029,10 @@ vfs_vmio_truncate(struct buf *bp, int desiredpages)
 
 	if (buf_mapped(bp)) {
 		BUF_CHECK_MAPPED(bp);
+#ifndef __rtems__
 		pmap_qremove((vm_offset_t)trunc_page((vm_offset_t)bp->b_data) +
 		    (desiredpages << PAGE_SHIFT), bp->b_npages - desiredpages);
+#endif /* __rtems__ */
 	} else
 		BUF_CHECK_UNMAPPED(bp);
 
@@ -2996,10 +3051,12 @@ vfs_vmio_truncate(struct buf *bp, int desiredpages)
 		m = bp->b_pages[i];
 		KASSERT(m != bogus_page, ("allocbuf: bogus page found"));
 		bp->b_pages[i] = NULL;
+#ifndef __rtems__
 		if (obj != NULL)
 			vm_page_release_locked(m, flags);
 		else
 			vm_page_release(m, flags);
+#endif /* __rtems__ */
 	}
 	if (obj != NULL)
 		VM_OBJECT_WUNLOCK(obj);
@@ -3039,11 +3096,13 @@ vfs_vmio_extend(struct buf *bp, int desiredpages, int size)
 		 * deadlocks once allocbuf() is called after
 		 * pages are vfs_busy_pages().
 		 */
+#ifndef __rtems__
 		(void)vm_page_grab_pages(obj,
 		    OFF_TO_IDX(bp->b_offset) + bp->b_npages,
 		    VM_ALLOC_SYSTEM | VM_ALLOC_IGN_SBUSY |
 		    VM_ALLOC_NOBUSY | VM_ALLOC_WIRED,
 		    &bp->b_pages[bp->b_npages], desiredpages - bp->b_npages);
+#endif /* __rtems__ */
 		bp->b_npages = desiredpages;
 	}
 
@@ -3079,9 +3138,11 @@ vfs_vmio_extend(struct buf *bp, int desiredpages, int size)
 	/*
 	 * Step 3, fixup the KVA pmap.
 	 */
+#ifdef __rtems__
 	if (buf_mapped(bp))
 		bpmap_qenter(bp);
 	else
+#endif /* __rtems__ */
 		BUF_CHECK_UNMAPPED(bp);
 }
 
@@ -3178,9 +3239,13 @@ vfs_bio_awrite(struct buf *bp)
 		 */
 		if (ncl != 1) {
 			BUF_UNLOCK(bp);
+#ifndef __rtems__
 			nwritten = cluster_wbuild(vp, size, lblkno - j, ncl,
 			    gbflags);
 			return (nwritten);
+#else /* __rtems__ */
+			panic("no cluster support");
+#endif /* __rtems__ */
 		}
 	}
 	bremfree(bp);
@@ -3330,8 +3395,10 @@ buf_daemon()
 	/*
 	 * This process needs to be suspended prior to shutdown sync.
 	 */
+#ifndef __rtems__
 	EVENTHANDLER_REGISTER(shutdown_pre_sync, kthread_shutdown, curthread,
 	    SHUTDOWN_PRI_LAST + 100);
+#endif /* __rtems__ */
 
 	/*
 	 * Start the buf clean daemons as children threads.
@@ -3354,7 +3421,9 @@ buf_daemon()
 		bd_request = 0;
 		mtx_unlock(&bdlock);
 
+#ifndef __rtems__
 		kthread_suspend_check();
+#endif /* __rtems__ */
 
 		/*
 		 * Save speedupreq for this pass and reset to capture new
@@ -3453,7 +3522,9 @@ flushbufqueues(struct vnode *lvp, struct bufdomain *bd, int target,
 	TAILQ_INSERT_HEAD(&bq->bq_queue, sentinel, b_freelist);
 	BQ_UNLOCK(bq);
 	while (flushed != target) {
+#ifndef __rtems__
 		maybe_yield();
+#endif /* __rtems__ */
 		BQ_LOCK(bq);
 		bp = TAILQ_NEXT(sentinel, b_freelist);
 		if (bp != NULL) {
@@ -3532,9 +3603,13 @@ flushbufqueues(struct vnode *lvp, struct bufdomain *bd, int target,
 		if (error == 0) {
 			CTR3(KTR_BUF, "flushbufqueue(%p) vp %p flags %X",
 			    bp, bp->b_vp, bp->b_flags);
+#ifndef __rtems__
 			if (curproc == bufdaemonproc) {
 				vfs_bio_awrite(bp);
 			} else {
+#else /* __rtems__ */
+			{
+#endif /* __rtems__ */
 				bremfree(bp);
 				bwrite(bp);
 				counter_u64_add(notbufdflushes, 1);
@@ -3549,7 +3624,11 @@ flushbufqueues(struct vnode *lvp, struct bufdomain *bd, int target,
 			 * Sleeping on runningbufspace while holding
 			 * vnode lock leads to deadlock.
 			 */
+#ifndef __rtems__
 			if (curproc == bufdaemonproc &&
+#else /* __rtems__ */
+			if (
+#endif /* __rtems__ */
 			    runningbufspace > hirunningspace)
 				waitrunningbufspace();
 			continue;
@@ -3587,6 +3666,7 @@ incore(struct bufobj *bo, daddr_t blkno)
 static int
 inmem(struct vnode * vp, daddr_t blkno)
 {
+#ifndef __rtems__
 	vm_object_t obj;
 	vm_offset_t toff, tinc, size;
 	vm_page_t m;
@@ -3625,6 +3705,9 @@ inmem(struct vnode * vp, daddr_t blkno)
 notinmem:
 	VM_OBJECT_RUNLOCK(obj);
 	return (0);
+#else /* __rtems__ */
+	return 1;
+#endif /* __rtems__ */
 }
 
 /*
@@ -3672,6 +3755,7 @@ vfs_clean_pages_dirty_buf(struct buf *bp)
 static void
 vfs_setdirty_locked_object(struct buf *bp)
 {
+#ifndef __rtems__
 	vm_object_t object;
 	int i;
 
@@ -3730,6 +3814,7 @@ vfs_setdirty_locked_object(struct buf *bp)
 				bp->b_dirtyend = eoffset;
 		}
 	}
+#endif /* __rtems__ */
 }
 
 /*
@@ -4470,6 +4555,7 @@ bufdone(struct buf *bp)
 void
 vfs_unbusy_pages(struct buf *bp)
 {
+#ifndef __rtems__
 	int i;
 	vm_object_t obj;
 	vm_page_t m;
@@ -4498,6 +4584,7 @@ vfs_unbusy_pages(struct buf *bp)
 	}
 	vm_object_pip_wakeupn(obj, bp->b_npages);
 	VM_OBJECT_WUNLOCK(obj);
+#endif /* __rtems__ */
 }
 
 /*
@@ -4511,6 +4598,7 @@ vfs_unbusy_pages(struct buf *bp)
 static void
 vfs_page_set_valid(struct buf *bp, vm_ooffset_t off, vm_page_t m)
 {
+#ifndef __rtems__
 	vm_ooffset_t eoff;
 
 	/*
@@ -4529,6 +4617,7 @@ vfs_page_set_valid(struct buf *bp, vm_ooffset_t off, vm_page_t m)
 	 */
 	if (eoff > off)
 		vm_page_set_valid_range(m, off & PAGE_MASK, eoff - off);
+#endif /* __rtems__ */
 }
 
 /*
@@ -4540,6 +4629,7 @@ vfs_page_set_valid(struct buf *bp, vm_ooffset_t off, vm_page_t m)
 static void
 vfs_page_set_validclean(struct buf *bp, vm_ooffset_t off, vm_page_t m)
 {
+#ifndef __rtems__
 	vm_ooffset_t soff, eoff;
 
 	/*
@@ -4564,6 +4654,7 @@ vfs_page_set_validclean(struct buf *bp, vm_ooffset_t off, vm_page_t m)
 		   (vm_offset_t) (eoff - soff)
 		);
 	}
+#endif /* __rtems__ */
 }
 
 /*
@@ -4573,6 +4664,7 @@ vfs_page_set_validclean(struct buf *bp, vm_ooffset_t off, vm_page_t m)
 void
 vfs_drain_busy_pages(struct buf *bp)
 {
+#ifndef __rtems__
 	vm_page_t m;
 	int i, last_busied;
 
@@ -4593,6 +4685,7 @@ vfs_drain_busy_pages(struct buf *bp)
 	}
 	for (i = 0; i < last_busied; i++)
 		vm_page_sunbusy(bp->b_pages[i]);
+#endif /* __rtems__ */
 }
 
 /*
@@ -4610,6 +4703,7 @@ vfs_drain_busy_pages(struct buf *bp)
 void
 vfs_busy_pages(struct buf *bp, int clear_modify)
 {
+#ifndef __rtems__
 	vm_object_t obj;
 	vm_ooffset_t foff;
 	vm_page_t m;
@@ -4666,6 +4760,7 @@ vfs_busy_pages(struct buf *bp, int clear_modify)
 		pmap_qenter(trunc_page((vm_offset_t)bp->b_data),
 		    bp->b_pages, bp->b_npages);
 	}
+#endif /* __rtems__ */
 }
 
 /*
@@ -4679,6 +4774,7 @@ vfs_busy_pages(struct buf *bp, int clear_modify)
 void   
 vfs_bio_set_valid(struct buf *bp, int base, int size)
 {
+#ifndef __rtems__
 	int i, n;
 	vm_page_t m;
 
@@ -4704,6 +4800,7 @@ vfs_bio_set_valid(struct buf *bp, int base, int size)
 		n = PAGE_SIZE;
 	}
 	VM_OBJECT_WUNLOCK(bp->b_bufobj->bo_object);
+#endif /* __rtems__ */
 }
 
 /*
@@ -4721,12 +4818,15 @@ vfs_bio_set_valid(struct buf *bp, int base, int size)
 void
 vfs_bio_clrbuf(struct buf *bp) 
 {
+#ifndef __rtems__
 	int i, j, mask, sa, ea, slide;
+#endif /* __rtems__ */
 
 	if ((bp->b_flags & (B_VMIO | B_MALLOC)) != B_VMIO) {
 		clrbuf(bp);
 		return;
 	}
+#ifndef __rtems__
 	bp->b_flags &= ~B_INVAL;
 	bp->b_ioflags &= ~BIO_ERROR;
 	VM_OBJECT_WLOCK(bp->b_bufobj->bo_object);
@@ -4773,6 +4873,7 @@ vfs_bio_clrbuf(struct buf *bp)
 unlock:
 	VM_OBJECT_WUNLOCK(bp->b_bufobj->bo_object);
 	bp->b_resid = 0;
+#endif /* __rtems__ */
 }
 
 void
@@ -4785,6 +4886,7 @@ vfs_bio_bzero_buf(struct buf *bp, int base, int size)
 		BUF_CHECK_MAPPED(bp);
 		bzero(bp->b_data + base, size);
 	} else {
+#ifndef __rtems__
 		BUF_CHECK_UNMAPPED(bp);
 		n = PAGE_SIZE - (base & PAGE_MASK);
 		for (i = base / PAGE_SIZE; size > 0 && i < bp->b_npages; ++i) {
@@ -4796,6 +4898,7 @@ vfs_bio_bzero_buf(struct buf *bp, int base, int size)
 			size -= n;
 			n = PAGE_SIZE;
 		}
+#endif /* __rtems__ */
 	}
 }
 
@@ -4848,6 +4951,7 @@ vfs_bio_set_flags(struct buf *bp, int ioflag)
 static void
 vm_hold_load_pages(struct buf *bp, vm_offset_t from, vm_offset_t to)
 {
+#ifndef __rtems__
 	vm_offset_t pg;
 	vm_page_t p;
 	int index;
@@ -4871,12 +4975,14 @@ vm_hold_load_pages(struct buf *bp, vm_offset_t from, vm_offset_t to)
 		bp->b_pages[index] = p;
 	}
 	bp->b_npages = index;
+#endif /* __rtems__ */
 }
 
 /* Return pages associated with this buf to the vm system */
 static void
 vm_hold_free_pages(struct buf *bp, int newbsize)
 {
+#ifndef __rtems__
 	vm_offset_t from;
 	vm_page_t p;
 	int index, newnpages;
@@ -4895,6 +5001,7 @@ vm_hold_free_pages(struct buf *bp, int newbsize)
 	}
 	vm_wire_sub(bp->b_npages - newnpages);
 	bp->b_npages = newnpages;
+#endif /* __rtems__ */
 }
 
 /*
@@ -4914,6 +5021,7 @@ vm_hold_free_pages(struct buf *bp, int newbsize)
 int
 vmapbuf(struct buf *bp, int mapbuf)
 {
+#ifndef __rtems__
 	vm_prot_t prot;
 	int pidx;
 
@@ -4933,6 +5041,7 @@ vmapbuf(struct buf *bp, int mapbuf)
 		bp->b_data = bp->b_kvabase + bp->b_offset;
 	} else
 		bp->b_data = unmapped_buf;
+#endif /* __rtems__ */
 	return(0);
 }
 
@@ -4945,6 +5054,7 @@ vmapbuf(struct buf *bp, int mapbuf)
 void
 vunmapbuf(struct buf *bp)
 {
+#ifndef __rtems__
 	int npages;
 
 	npages = bp->b_npages;
@@ -4953,6 +5063,7 @@ vunmapbuf(struct buf *bp)
 	vm_page_unhold_pages(bp->b_pages, npages);
 
 	bp->b_data = unmapped_buf;
+#endif /* __rtems__ */
 }
 
 void
@@ -5136,6 +5247,7 @@ vfs_bio_getpages(struct vnode *vp, vm_page_t *ma, int count,
     int *rbehind, int *rahead, vbg_get_lblkno_t get_lblkno,
     vbg_get_blksize_t get_blksize)
 {
+#ifndef __rtems__
 	vm_page_t m;
 	vm_object_t object;
 	struct buf *bp;
@@ -5282,11 +5394,23 @@ end_pages:
 		goto again;
 	VM_OBJECT_WUNLOCK(object);
 	return (error != 0 ? VM_PAGER_ERROR : VM_PAGER_OK);
+#else /* __rtems__ */
+	return (0);
+#endif /* __rtems__ */
 }
 
-#include "opt_ddb.h"
+#include <rtems/bsd/local/opt_ddb.h>
+#ifdef __rtems__
+#define DB_SHOW_COMMAND(cmd_name, func_name) \
+   void rtems_bsd_cmd_ ## func_name(caddr_t addr, bool have_addr, int count, char* modif)
+#define db_printf printf
+#define db_show_buffer rtems_bsd_cmd_db_show_buffer
+#define DDB
+#endif /* __rtems__ */
 #ifdef DDB
+#ifndef __rtems__
 #include <ddb/ddb.h>
+#endif /* __rtems__ */
 
 /* DDB command to show buffer data */
 DB_SHOW_COMMAND(buffer, db_show_buffer)
@@ -5322,9 +5446,13 @@ DB_SHOW_COMMAND(buffer, db_show_buffer)
 			vm_page_t m;
 			m = bp->b_pages[i];
 			if (m != NULL)
+#ifndef __rtems__
 				db_printf("(%p, 0x%lx, 0x%lx)", m->object,
 				    (u_long)m->pindex,
 				    (u_long)VM_PAGE_TO_PHYS(m));
+#else /* __rtems__ */
+				db_printf("(%p)", m);
+#endif /* __rtems__ */
 			else
 				db_printf("( ??? )");
 			if ((i + 1) < bp->b_npages)
@@ -5421,8 +5549,10 @@ DB_SHOW_COMMAND(lockedbufs, lockedbufs)
 		if (BUF_ISLOCKED(bp)) {
 			db_show_buffer((uintptr_t)bp, 1, 0, NULL);
 			db_printf("\n");
+#ifndef __rtems__
 			if (db_pager_quit)
 				break;
+#endif /* __rtems__ */
 		}
 	}
 }
@@ -5449,6 +5579,7 @@ DB_SHOW_COMMAND(vnodebufs, db_show_vnodebufs)
 	}
 }
 
+#ifndef __rtems__
 DB_COMMAND(countfreebufs, db_coundfreebufs)
 {
 	struct buf *bp;
@@ -5471,4 +5602,11 @@ DB_COMMAND(countfreebufs, db_coundfreebufs)
 	    nfree + used);
 	db_printf("numfreebuffers is %d\n", numfreebuffers);
 }
+#endif /* __rtems__ */
 #endif /* DDB */
+#ifdef __rtems__
+void rtems_bsd_bio_dump(void)
+{
+  rtems_bsd_cmd_bufqueues(0, true, 0, NULL);
+}
+#endif /* __rtems__ */
diff --git a/freebsd/sys/kern/vfs_cache.c b/freebsd/sys/kern/vfs_cache.c
index 7c14b080..7ae1de1d 100644
--- a/freebsd/sys/kern/vfs_cache.c
+++ b/freebsd/sys/kern/vfs_cache.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -37,8 +39,8 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_ddb.h"
-#include "opt_ktrace.h"
+#include <rtems/bsd/local/opt_ddb.h>
+#include <rtems/bsd/local/opt_ktrace.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -339,12 +341,14 @@ cache_out_ts(struct namecache *ncp, struct timespec *tsp, int *ticksp)
 }
 
 static int __read_mostly	doingcache = 1;	/* 1 => enable the cache */
+#ifndef __rtems__
 SYSCTL_INT(_debug, OID_AUTO, vfscache, CTLFLAG_RW, &doingcache, 0,
     "VFS namecache enabled");
 
 /* Export size information to userland */
 SYSCTL_INT(_debug_sizeof, OID_AUTO, namecache, CTLFLAG_RD, SYSCTL_NULL_INT_PTR,
     sizeof(struct namecache), "sizeof(struct namecache)");
+#endif /* __rtems__ */
 
 /*
  * The new name cache statistics
@@ -397,10 +401,12 @@ static void
 cache_maybe_yield(void)
 {
 
+#ifndef __rtems__
 	if (should_yield()) {
 		cache_yield++;
 		kern_yield(PRI_USER);
 	}
+#endif /* __rtems__ */
 }
 
 static inline void
@@ -1918,7 +1924,11 @@ nchinit(void *dummy __unused)
 	numfullpathfail4 = counter_u64_alloc(M_WAITOK);
 	numfullpathfound = counter_u64_alloc(M_WAITOK);
 }
+#ifndef __rtems__
 SYSINIT(vfs, SI_SUB_VFS, SI_ORDER_SECOND, nchinit, NULL);
+#else /* __rtems__ */
+SYSINIT(vfs_c, SI_SUB_VFS, SI_ORDER_SECOND, nchinit, NULL);
+#endif /* __rtems__ */
 
 void
 cache_changesize(int newmaxvnodes)
diff --git a/freebsd/sys/kern/vfs_cluster.c b/freebsd/sys/kern/vfs_cluster.c
index 1ebe4a56..cae35911 100644
--- a/freebsd/sys/kern/vfs_cluster.c
+++ b/freebsd/sys/kern/vfs_cluster.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -36,7 +38,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_debug_cluster.h"
+#include <rtems/bsd/local/opt_debug_cluster.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -254,7 +256,9 @@ cluster_read(struct vnode *vp, u_quad_t filesize, daddr_t lblkno, long size,
 			PROC_UNLOCK(td->td_proc);
 		}
 #endif /* RACCT */
+#ifndef __rtems__
 		td->td_ru.ru_inblock++;
+#endif /* __rtems__ */
 	}
 
 	/*
@@ -314,7 +318,9 @@ cluster_read(struct vnode *vp, u_quad_t filesize, daddr_t lblkno, long size,
 			PROC_UNLOCK(td->td_proc);
 		}
 #endif /* RACCT */
+#ifndef __rtems__
 		td->td_ru.ru_inblock++;
+#endif /* __rtems__ */
 	}
 
 	if (reqbp) {
@@ -447,6 +453,7 @@ cluster_rbuild(struct vnode *vp, u_quad_t filesize, daddr_t lbn,
 			 * take part in the cluster.  If it is partially valid
 			 * then we stop.
 			 */
+#ifndef __rtems__
 			off = tbp->b_offset;
 			tsize = size;
 			VM_OBJECT_WLOCK(tbp->b_bufobj->bo_object);
diff --git a/freebsd/sys/kern/vfs_default.c b/freebsd/sys/kern/vfs_default.c
index 40041c9d..6aabb760 100644
--- a/freebsd/sys/kern/vfs_default.c
+++ b/freebsd/sys/kern/vfs_default.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -46,13 +48,15 @@ __FBSDID("$FreeBSD$");
 #include <sys/kernel.h>
 #include <sys/limits.h>
 #include <sys/lock.h>
+#ifndef __rtems__
 #include <sys/lockf.h>
+#endif /* __rtems__ */
 #include <sys/malloc.h>
 #include <sys/mount.h>
 #include <sys/namei.h>
 #include <sys/rwlock.h>
 #include <sys/fcntl.h>
-#include <sys/unistd.h>
+#include <rtems/bsd/sys/unistd.h>
 #include <sys/vnode.h>
 #include <sys/dirent.h>
 #include <sys/poll.h>
@@ -66,7 +70,9 @@ __FBSDID("$FreeBSD$");
 #include <vm/vm_map.h>
 #include <vm/vm_page.h>
 #include <vm/vm_pager.h>
+#ifndef __rtems__
 #include <vm/vnode_pager.h>
+#endif /* __rtems__ */
 
 static int	vop_nolookup(struct vop_lookup_args *);
 static int	vop_norename(struct vop_rename_args *);
@@ -401,6 +407,7 @@ vop_stdaccessx(struct vop_accessx_args *ap)
 int
 vop_stdadvlock(struct vop_advlock_args *ap)
 {
+#ifndef __rtems__
 	struct vnode *vp;
 	struct vattr vattr;
 	int error;
@@ -422,11 +429,15 @@ vop_stdadvlock(struct vop_advlock_args *ap)
 		vattr.va_size = 0;
 
 	return (lf_advlock(ap, &(vp->v_lockf), vattr.va_size));
+#else /* __rtems__ */
+	return (EINVAL);
+#endif /* __rtems__ */
 }
 
 int
 vop_stdadvlockasync(struct vop_advlockasync_args *ap)
 {
+#ifndef __rtems__
 	struct vnode *vp;
 	struct vattr vattr;
 	int error;
@@ -443,16 +454,23 @@ vop_stdadvlockasync(struct vop_advlockasync_args *ap)
 		vattr.va_size = 0;
 
 	return (lf_advlockasync(ap, &(vp->v_lockf), vattr.va_size));
+#else /* __rtems__ */
+	return (EINVAL);
+#endif /* __rtems__ */
 }
 
 int
 vop_stdadvlockpurge(struct vop_advlockpurge_args *ap)
 {
+#ifndef __rtems__
 	struct vnode *vp;
 
 	vp = ap->a_vp;
 	lf_purgelocks(vp, &vp->v_lockf);
 	return (0);
+#else /* __rtems__ */
+	return (EINVAL);
+#endif /* __rtems__ */
 }
 
 /*
@@ -670,20 +688,28 @@ vop_stdgetpages(ap)
 		int *a_rahead;
 	} */ *ap;
 {
+#ifndef __rtems__
 
 	return vnode_pager_generic_getpages(ap->a_vp, ap->a_m,
 	    ap->a_count, ap->a_rbehind, ap->a_rahead, NULL, NULL);
+#else /* __rtems__ */
+	return EINVAL;
+#endif /* __rtems__ */
 }
 
 static int
 vop_stdgetpages_async(struct vop_getpages_async_args *ap)
 {
+#ifndef __rtems__
 	int error;
 
 	error = VOP_GETPAGES(ap->a_vp, ap->a_m, ap->a_count, ap->a_rbehind,
 	    ap->a_rahead);
 	ap->a_iodone(ap->a_arg, ap->a_m, ap->a_count, error);
 	return (error);
+#else /* __rtems__ */
+	return EINVAL;
+#endif /* __rtems__ */
 }
 
 int
@@ -703,9 +729,13 @@ vop_stdputpages(ap)
 		int *a_rtvals;
 	} */ *ap;
 {
+#ifndef __rtems__
 
 	return vnode_pager_generic_putpages(ap->a_vp, ap->a_m, ap->a_count,
 	     ap->a_sync, ap->a_rtvals);
+#else /* __rtems__ */
+	return EINVAL;
+#endif /* __rtems__ */
 }
 
 int
@@ -962,8 +992,10 @@ vop_stdallocate(struct vop_allocate_args *ap)
 		offset += cur;
 		if (len == 0)
 			break;
+#ifndef __rtems__
 		if (should_yield())
 			break;
+#endif /* __rtems__ */
 	}
 
  out:
@@ -984,6 +1016,7 @@ vop_stdadvise(struct vop_advise_args *ap)
 
 	vp = ap->a_vp;
 	switch (ap->a_advice) {
+#ifndef __rtems__
 	case POSIX_FADV_WILLNEED:
 		/*
 		 * Do nothing for now.  Filesystems should provide a
@@ -1026,6 +1059,7 @@ vop_stdadvise(struct vop_advise_args *ap)
 		BO_RUNLOCK(bo);
 		VOP_UNLOCK(vp, 0);
 		break;
+#endif /* __rtems__ */
 	default:
 		error = EINVAL;
 		break;
diff --git a/freebsd/sys/kern/vfs_export.c b/freebsd/sys/kern/vfs_export.c
index 669d4e9f..511ab05d 100644
--- a/freebsd/sys/kern/vfs_export.c
+++ b/freebsd/sys/kern/vfs_export.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -39,8 +41,8 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_inet.h"
-#include "opt_inet6.h"
+#include <rtems/bsd/local/opt_inet.h>
+#include <rtems/bsd/local/opt_inet6.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -61,7 +63,12 @@ __FBSDID("$FreeBSD$");
 #include <netinet/in.h>
 #include <net/radix.h>
 
+#ifndef __rtems__
 static MALLOC_DEFINE(M_NETADDR, "export_host", "Export host address structure");
+#else /* __rtems__ */
+static MALLOC_DEFINE(M_NETADDR_e, "export_host", "Export host address structure");
+#define M_NETADDR M_NETADDR_e
+#endif /* __rtems__ */
 
 #if defined(INET) || defined(INET6)
 static struct radix_node_head *vfs_create_addrlist_af(
@@ -119,11 +126,13 @@ vfs_hang_addrlist(struct mount *mp, struct netexport *nep,
 	 * with fields like cr_uidinfo and cr_prison?  Currently, this
 	 * routine does not touch them (leaves them as NULL).
 	 */
+#ifndef __rtems__
 	if (argp->ex_anon.cr_version != XUCRED_VERSION) {
 		vfs_mount_error(mp, "ex_anon.cr_version: %d != %d",
 		    argp->ex_anon.cr_version, XUCRED_VERSION);
 		return (EINVAL);
 	}
+#endif /* __rtems__ */
 
 	if (argp->ex_addrlen == 0) {
 		if (mp->mnt_flag & MNT_DEFEXPORTED) {
@@ -134,11 +143,13 @@ vfs_hang_addrlist(struct mount *mp, struct netexport *nep,
 		np = &nep->ne_defexported;
 		np->netc_exflags = argp->ex_flags;
 		np->netc_anon = crget();
+#ifndef __rtems__
 		np->netc_anon->cr_uid = argp->ex_anon.cr_uid;
 		crsetgroups(np->netc_anon, argp->ex_anon.cr_ngroups,
 		    argp->ex_anon.cr_groups);
 		np->netc_anon->cr_prison = &prison0;
 		prison_hold(np->netc_anon->cr_prison);
+#endif /* __rtems__ */
 		np->netc_numsecflavors = argp->ex_numsecflavors;
 		bcopy(argp->ex_secflavors, np->netc_secflavors,
 		    sizeof(np->netc_secflavors));
@@ -213,11 +224,13 @@ vfs_hang_addrlist(struct mount *mp, struct netexport *nep,
 	}
 	np->netc_exflags = argp->ex_flags;
 	np->netc_anon = crget();
+#ifndef __rtems__
 	np->netc_anon->cr_uid = argp->ex_anon.cr_uid;
 	crsetgroups(np->netc_anon, argp->ex_anon.cr_ngroups,
 	    argp->ex_anon.cr_groups);
 	np->netc_anon->cr_prison = &prison0;
 	prison_hold(np->netc_anon->cr_prison);
+#endif /* __rtems__ */
 	np->netc_numsecflavors = argp->ex_numsecflavors;
 	bcopy(argp->ex_secflavors, np->netc_secflavors,
 	    sizeof(np->netc_secflavors));
@@ -525,4 +538,3 @@ vfs_stdcheckexp(struct mount *mp, struct sockaddr *nam, int *extflagsp,
 	lockmgr(&mp->mnt_explock, LK_RELEASE, NULL);
 	return (0);
 }
-
diff --git a/freebsd/sys/kern/vfs_extattr.c b/freebsd/sys/kern/vfs_extattr.c
index 2903fd37..6d3181e9 100644
--- a/freebsd/sys/kern/vfs_extattr.c
+++ b/freebsd/sys/kern/vfs_extattr.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-2-Clause-FreeBSD
  *
@@ -491,6 +493,8 @@ kern_extattr_get_path(struct thread *td, const char *path, int attrnamespace,
  * References: vp must be a valid reference for the duration of the call
  */
 static int
+
+
 extattr_delete_vp(struct vnode *vp, int attrnamespace, const char *attrname,
     struct thread *td)
 {
diff --git a/freebsd/sys/kern/vfs_hash.c b/freebsd/sys/kern/vfs_hash.c
index b938f485..5fa50a5e 100644
--- a/freebsd/sys/kern/vfs_hash.c
+++ b/freebsd/sys/kern/vfs_hash.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-2-Clause-FreeBSD
  *
diff --git a/freebsd/sys/kern/vfs_init.c b/freebsd/sys/kern/vfs_init.c
index 5eb38e6d..f58d90c2 100644
--- a/freebsd/sys/kern/vfs_init.c
+++ b/freebsd/sys/kern/vfs_init.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -69,7 +71,11 @@ int maxvfsconf = VFS_GENERIC + 1;
  */
 struct vfsconfhead vfsconf = TAILQ_HEAD_INITIALIZER(vfsconf);
 struct sx vfsconf_sx;
+#ifndef __rtems__
 SX_SYSINIT(vfsconf, &vfsconf_sx, "vfsconf");
+#else /* __rtems__ */
+SX_SYSINIT_FLAGS(vfsconf, &vfsconf_sx, "vfsconf", SX_RECURSE);
+#endif /* __rtems__ */
 
 /*
  * Loader.conf variable vfs.typenumhash enables setting vfc_typenum using a hash
@@ -147,18 +153,22 @@ vfs_byname_kld(const char *fstype, struct thread *td, int *error)
 		return (vfsp);
 
 	/* Try to load the respective module. */
+#ifndef __rtems__
 	*error = kern_kldload(td, fstype, &fileid);
 	loaded = (*error == 0);
 	if (*error == EEXIST)
 		*error = 0;
 	if (*error)
 		return (NULL);
+#endif /* __rtems__ */
 
 	/* Look up again to see if the VFS was loaded. */
 	vfsp = vfs_byname(fstype);
 	if (vfsp == NULL) {
+#ifndef __rtems__
 		if (loaded)
 			(void)kern_kldunload(td, fileid, LINKER_UNLOAD_FORCE);
+#endif /* __rtems__ */
 		*error = ENODEV;
 		return (NULL);
 	}
@@ -278,8 +288,10 @@ vfs_register(struct vfsconf *vfc)
 	if (vfsops->vfs_sysctl == NULL)
 		vfsops->vfs_sysctl = vfs_stdsysctl;
 
+#ifndef __rtems__
 	if (vfc->vfc_flags & VFCF_JAIL)
 		prison_add_vfs(vfc);
+#endif /* __rtems__ */
 
 	/*
 	 * Call init function for this VFS...
@@ -297,6 +309,7 @@ vfs_register(struct vfsconf *vfc)
 	 * preserved by re-registering the oid after modifying its
 	 * number.
 	 */
+#ifndef __rtems__
 	sysctl_wlock();
 	SLIST_FOREACH(oidp, SYSCTL_CHILDREN(&sysctl___vfs), oid_link) {
 		if (strcmp(oidp->oid_name, vfc->vfc_name) == 0) {
@@ -307,6 +320,7 @@ vfs_register(struct vfsconf *vfc)
 		}
 	}
 	sysctl_wunlock();
+#endif /* __rtems__ */
 
 	return (0);
 }
diff --git a/freebsd/sys/kern/vfs_lookup.c b/freebsd/sys/kern/vfs_lookup.c
index 5ee3f219..656ec51d 100644
--- a/freebsd/sys/kern/vfs_lookup.c
+++ b/freebsd/sys/kern/vfs_lookup.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -39,8 +41,8 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_capsicum.h"
-#include "opt_ktrace.h"
+#include <rtems/bsd/local/opt_capsicum.h>
+#include <rtems/bsd/local/opt_ktrace.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -158,7 +160,11 @@ nameiinit(void *dummy __unused)
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
 	getnewvnode("crossmp", NULL, &crossmp_vnodeops, &vp_crossmp);
 }
+#ifndef __rtems__
 SYSINIT(vfs, SI_SUB_VFS, SI_ORDER_SECOND, nameiinit, NULL);
+#else /* __rtems__ */
+SYSINIT(vfs_l, SI_SUB_VFS, SI_ORDER_SECOND, nameiinit, NULL);
+#endif /* __rtems__ */
 
 static int lookup_cap_dotdot = 1;
 SYSCTL_INT(_vfs, OID_AUTO, lookup_cap_dotdot, CTLFLAG_RWTUN,
@@ -557,6 +563,7 @@ static int
 compute_cn_lkflags(struct mount *mp, int lkflags, int cnflags)
 {
 
+#ifndef __rtems__
 	if (mp == NULL || ((lkflags & LK_SHARED) &&
 	    (!(mp->mnt_kern_flag & MNTK_LOOKUP_SHARED) ||
 	    ((cnflags & ISDOTDOT) &&
@@ -565,6 +572,7 @@ compute_cn_lkflags(struct mount *mp, int lkflags, int cnflags)
 		lkflags |= LK_EXCLUSIVE;
 	}
 	lkflags |= LK_NODDLKTREAT;
+#endif /* __rtems__ */
 	return (lkflags);
 }
 
@@ -820,10 +828,14 @@ dirloop:
 			goto bad;
 		}
 		for (;;) {
+#ifndef __rtems__
 			for (pr = cnp->cn_cred->cr_prison; pr != NULL;
 			     pr = pr->pr_parent)
 				if (dp == pr->pr_root)
 					break;
+#else /* __rtems__ */
+			pr = NULL;
+#endif /* __rtems__ */
 			if (dp == ndp->ni_rootdir || 
 			    dp == ndp->ni_topdir || 
 			    dp == rootvnode ||
